
//	Copyright (c) 1982 Dyadic Systems Limited	

/*	x f a c c

	external function access routines
*/

#include "apl.h"

extern ARRAY *mkarray();
extern int	domain();

unsigned char   (*initchar())();
short           (*initintg())();
int             (*initdint())();
long            (*initlong())();
double          (*initdoub())();
ARRAY           *(*initpntr())();

//	d o u b l e   p u t  &  g e t	

typedef	struct {
	unsigned char cfloat[sizeof(double)];
} Doubarray;

typedef struct {
	union {
		Doubarray sfloat;
		double dfloat;
	} ufloat;
} Doubunion;

putd(val, base, indx)
double val, *base;
unsigned indx;
{
#ifdef	DALIGN
	Doubunion dunion;

	dunion.ufloat.dfloat = val;
	*((Doubarray*)(base+indx)) = dunion.ufloat.sfloat;
#else
	base[indx] = val;
#endif // DALIGN 
}

double getd(base, indx)
double *base;
unsigned indx;
{
#ifdef	DALIGN
	Doubunion dunion;

	dunion.ufloat.sfloat = *((Doubarray*)(base+indx));
	return dunion.ufloat.dfloat;
#else

#ifdef	PYRAMID
#define	COMP_BUG
#endif	// PYRAMID 
#ifdef	MASS
#define	COMP_BUG
#endif	// MASS 

#ifdef COMP_BUG
	double d;
	d = base[indx];
	return d;
#undef	COMP_BUG
#else
	return base[indx];
#endif // COMP_BUG 

#endif // DALIGN 
}
//	c h a r  f r o m  a n y t h i n g  ( s u i t a b l e )	

static unsigned char cgetc(base,indx)
unsigned char *base;
unsigned indx;
{
	return base[indx];
}

static unsigned char cgetp(base,indx)
ARRAY **base;
unsigned indx;
{
	register ARRAY *array = base[indx];

	if			// subarray should be simple scalar
		(
		array->eltype == PNTR
	||	array->rank
		) domain();

	return (*initchar(array))(array->shape, 0);
}
//	i n t   f r o m   a n y t h i n g	

static short igetb(base,indx)
unsigned char *base;
unsigned indx;
{
	return ((base[indx>>3] << (indx&7)) & 0x80 ) != 0;
}

static short igets(base,indx)
signed char *base;
unsigned indx;
{
	return base[indx];
}

static short igeti(base,indx)
short *base;
unsigned indx;
{
	return base[indx];
}

static short igetl(base,indx)
long *base;
unsigned indx;
{
	return base[indx];
}

static short igetd(base,indx)	// rounds double to nearest int 
double *base;
unsigned indx;
{
	long round();
#ifdef	DALIGN
	Doubunion dunion;

	dunion.ufloat.sfloat = *((Doubarray*)(base+indx));
	return round(dunion.ufloat.dfloat);
#else
	return round(base[indx]);
#endif // DALIGN 
}

static short igetp(base,indx)
ARRAY **base;
unsigned indx;
{
	register ARRAY *array = base[indx];

	if			// subarray should be simple scalar
		(
		array->eltype == PNTR
	||	array->rank
		) domain();

	return (*initintg(array))(array->shape, 0);
}
//	l o n g   f r o m   a n y t h i n g	

static long lgetb(base,indx)
unsigned char *base;
unsigned indx;
{
	return ((base[indx>>3] << (indx&7)) & 0x80 ) != 0;
}

static long lgets(base,indx)
signed char *base;
unsigned indx;
{
	return base[indx];
}

static long lgeti(base,indx)
short *base;
unsigned indx;
{
	return base[indx];
}

static long lgetl(base,indx)
long *base;
unsigned indx;
{
	return base[indx];
}

static long lgetd(base,indx)	// rounds double to nearest long 
double *base;
unsigned indx;
{
	long round();
#ifdef	DALIGN
	Doubunion dunion;

	dunion.ufloat.sfloat = *((Doubarray*)(base+indx));
	return round(dunion.ufloat.dfloat);
#else
	return round(base[indx]);
#endif // DALIGN 
}

static long lgetp(base,indx)
ARRAY **base;
unsigned indx;
{
	register ARRAY *array = base[indx];

	if			// subarray should be simple scalar
		(
		array->eltype == PNTR
	||	array->rank
		) domain();

	return (*initlong(array))(array->shape, 0);
}
//	d o u b l e   f r o m   a n y t h i n g	

static double dgetb(base,indx)
unsigned char *base;
unsigned indx;
{
	return ((base[indx>>3] << (indx&7)) & 0x80 ) != 0;
}

static double dgets(base,indx)
signed char *base;
unsigned indx;
{
	return  (int)base[indx];
}

static double dgeti(base,indx)
short *base;
unsigned indx;
{
	return base[indx];
}

static double dgetl(base,indx)
long *base;
unsigned indx;
{
	return base[indx];
}

static double dgetp(base,indx)
ARRAY **base;
unsigned indx;
{
	register ARRAY *array = base[indx];

	if			// subarray should be simple scalar
		(
		array->eltype == PNTR
	||	array->rank
		) domain();
	return (*initdoub(array))(array->shape, 0);
}
//	p n t r  f r o m  a n y t h i n g	

static ARRAY *pgetc(base,indx)
unsigned char *base;
unsigned indx;
{
	register ARRAY *array;

	array = mkarray(CHAR, 0, 0);

	*(unsigned char *)array->shape = base[indx];

	return array;
}

static ARRAY *pgetb(base,indx)
unsigned char *base;
unsigned indx;
{
	register ARRAY *array;

	array = mkarray(LONG, 0, 0);

	*(long *)array->shape = lgetb(base,indx);

	return array;
}

static ARRAY *pgets(base,indx)
signed char *base;
unsigned indx;
{
	register ARRAY *array;

	array = mkarray(LONG, 0, 0);

	*(long *)array->shape = base[indx];

	return array;
}

static ARRAY *pgeti(base,indx)
short *base;
unsigned indx;
{
	register ARRAY *array;

	array = mkarray(LONG, 0, 0);

	*(long *)array->shape = base[indx];

	return array;
}

static ARRAY *pgetl(base,indx)
long *base;
unsigned indx;
{
	register ARRAY *array;

	array = mkarray(LONG, 0, 0);

	*(long *)array->shape = base[indx];

	return array;
}

static ARRAY *pgetd(base,indx)
double *base;
unsigned indx;
{
	register ARRAY *array;

	array = mkarray(DOUB, 0, 0);

	*(double *)array->shape = base[indx];

	return array;
}

static ARRAY *pgetp(base, indx)
ARRAY **base;
unsigned indx;
{
	return base[indx];
}
//	S E R V I C E S		

static unsigned char (*charfns[])() = 
{
			cgetc,
(unsigned char(*)())	domain,				// BOOL 
(unsigned char(*)())	domain,				// SINT 
(unsigned char(*)())	domain,				// INTG 
(unsigned char(*)())	domain,				// LONG 
(unsigned char(*)())	domain,				// DOUB 
			cgetp
};

static short (*shortfns[])() =
{
(short(*)())	domain,					// CHAR	
		igetb, igets, igeti, igetl, igetd, igetp
};

static long (*longfns[])() =
{
(long(*)())	domain,					// CHAR	
		lgetb, lgets, lgeti, lgetl, lgetd, lgetp
};

static	double	(*doublefns[])() = 
{
(double(*)()) 	domain,					// CHAR 
		dgetb, dgets, dgeti, dgetl, getd, dgetp
};

static ARRAY	*(*pntrfns[])() = 
{
		pgetc, pgetb, pgets, pgeti, pgetl, pgetd, pgetp
};

unsigned char (*initchar(array))()
ARRAY *array;
{
	return charfns[array->eltype];
}

short (*initintg(array))()
ARRAY *array;
{
	return shortfns[array->eltype];
}

int (*initdint(array))()
ARRAY *array;
{
	return (sizeof(int) == sizeof(short)
			? (int (**)())shortfns
			: (int (**)())longfns)[array->eltype];
}

long (*initlong(array))()
ARRAY *array;
{
	return longfns[array->eltype];
}

double	(*initdoub(array))()
ARRAY	*array;
{
	return doublefns[array->eltype];
}

ARRAY	*(*initpntr(array))()
ARRAY	*array;
{
	return pntrfns[array->eltype];
}

static long	round(fval)
double fval;
	{
	static double max = 0x7fffffff;
	static double min = (double)(-1) - (double) 0x7fffffff;

	fval += (fval<0 ? -.5:.5);
	if(min > fval || max < fval)
		domain();
	return fval;
	}

//	Copyright (c) 1982 Dyadic Systems Limited	
