#include	<stdlib.h>
#include	<stdio.h>
#include	<io.h>
#include	<fcntl.h>
#include	<share.H>
#include	<string.h>
#include	<signal.h>
#include	"apl.h"

#if	defined(DOS)
#	include	"msdos.cf"	// this placing is critical to minimise 
				// name clashes with support.h and quadav.h 
#endif	// defined(DOS) 

#include	"support.h"
#include	"quadav.h"

unsigned char taskid[] = "prt";

#define	PRT		1
#define	ARBOUT		2
#define	OFF		3
#define	ARGS		4
#define GOTARGS		999

FILE * device = 0;	// the device to which we will talk 
FILE * font = 0;	// the font we will download 
unsigned char * aplt1 = 0;// the translate file we will use 
int printer = 0;	// the printer to which we are talking 
int funcode;

#if	defined(ANSI)
extern void * (*special_getenv)(const void *);
extern void exit(int);

static void		* prt_getenv(const void * envname);
static void		downloadfont(void);
static void		setaplt1(ARRAY *rarg);
static void		setdevice(ARRAY *rarg);
static void		closedevice(void);
static void		setfont(ARRAY *rarg);
static void		closefont(void);
static void		args(ARRAY *rarg);
static void		prt_error(unsigned char * s, int loc);
static void		prt_tr_error(int err_code);
static void		finish(void);
static void		arbout(ARRAY * rarg);
static void		prt(unsigned rows, unsigned cols, unsigned char * cp);
static void		out_error(void);
static void		submain(void);
static unsigned char *	f_fname(unsigned char * name);
static int 		out_printer(unsigned char *buf, unsigned count);
extern int		(*out_fn)(char *buf, unsigned count);// from trans.c 
extern int		(*out_fail)(void);		// from trans.c 
static int		pwrite(unsigned char *buf, unsigned count);
unsigned char *		fextend(unsigned char * name, unsigned char * ext);

#else	// defined(ANSI) 

extern void * (*special_getenv)();
extern void exit();

static void		* prt_getenv();
static void		downloadfont();
static void		setaplt1();
static void		setdevice();
static void		closedevice();
static void		setfont();
static void		closefont();
static void		args();
static void		prt_error();
static void		prt_tr_error();
static void		finish();
static void		arbout();
static void		prt();
static void		out_error();
static void		submain();
static unsigned char *	f_fname();
static int 		out_printer();
extern int		(*out_fn)();
extern int		(*out_fail)();
static int		pwrite();
unsigned char *		fextend();
#endif	// defined(ANSI) 

#if	defined(DOS)
	main()
#elif	defined(WATCOM)
	win_main(int argc, unsigned char *argv[])
#else
	main(argc, argv)
	int	argc;
	unsigned char	*argv[];
#endif	// DOS 
{
void submain();
ARRAY *rarg = 0, *rslt = 0;

special_getenv = prt_getenv;
#if	defined(DOS)
	device = fopen("lpt1", "wb");
#elif	defined(WINDOWS3)
	// no defaults for now
	printer = -1;
#else	// defined(DOS) 
	// set the defaults for UNIX 
	aplt1 = getenv("APLT1");
	device = stdout;
	printer = -1;
	signal(SIGPIPE, out_error);
#endif	// defined(DOS) 
startup(4);
define("prtargs", MONA|SHYR, ARGS);
define("prt", MONA|SHYR, PRT);
define("arbout", MONA|SHYR, ARBOUT);
define("prtoff", SHYR, OFF);

setjmp(errbuff);		// come here after an error	


for(;;putarray(rslt))
	{
	rarg = freearray(rarg);
	rslt = freearray(rslt);
	switch(funcode = fromapl())
		{
	case PRT: case ARBOUT:
		break;	// we are now committed 
	case OFF:
		closedevice();
		closefont();
		exit(0);
	case -1:
		closedevice();
		closefont();
		continue;
	case ARGS:
		args(rarg = getarray());
		funcode = GOTARGS;
		break;
		}
	break;
	}
if(font)downloadfont();
	{
	extern void (*x_error)();

	x_error = prt_tr_error;	// do sensible thing if cant read translate 
	}
o_init();		// get the translate tables
submain();
}

static void submain()
{
ARRAY *rarg = 0, *rslt = 0;

if(setjmp(errbuff))	// come here after an error	
	funcode = fromapl();
for(;; putarray(rslt), funcode = fromapl())
	{
	rarg = freearray(rarg);
	rslt = freearray(rslt);
	switch(funcode)
		{
		case GOTARGS:
			break;
		case PRT:
			{
			unsigned rank;

			rarg = getarray();
			if(rarg->type != SIMPLE)prt_error("not simple",DOMAIN);
			rank = rarg->rank;
			if(rank > 2)prt_error("not matrix",RANK);
			if(rarg->eltype != CHAR)prt_error("not character",DOMAIN);
			prt
				(
				rank == 2 ? rarg->shape[0] : 1,	// rows 
				rank > 0 ? rarg->shape[rank - 1] : 1,	// cols 
				(unsigned char *)&rarg->shape[rank]// first char
				);
			break;
			}
		case ARBOUT:
			arbout(rarg = getarray());
			break;
		case OFF:
			finish();
			exit(0);
		case -1:
			finish();
			break;
		default: prt_error("illegal function",DOMAIN);
			break;
		}
	}
}

static void out_error()
{
prt_error("failed to write",FERR); return;
}


static int pwrite( unsigned char *buf, unsigned count)
{
	return fwrite(buf, 1, count, device);
}

static void prt(         rows,          cols,                cp)
                unsigned rows; unsigned cols; unsigned char *cp;
{
register unsigned c, r;

if(aplt1)	// using a translate table 
	{
	init_out(device, out_error);
	if(printer != -1) out_fn = out_printer;		// DOS cludge 
	for(r = rows; r--;)
		{
		for(c = cols; c--;)avtoasc(*cp++);
		avtoasc(NEWLINE);
		}
	}
else		// untranslated 
	{
	static unsigned char newline[] = { '\r', '\n' };
	unsigned char *p = (char *)cp;
	int (*out_fn)() = printer == -1 ? pwrite : out_printer;

	for(r = rows; r--; p += cols) if
		(
		cols != (*out_fn)(p, cols) ||
		sizeof(newline) != (*out_fn)(newline, sizeof(newline))
		)
		out_error();
	}
fflush(device);
}

static void arbout(                rarg)
                   register ARRAY *rarg;
{
if(rarg->type != SIMPLE)prt_error("not simple",DOMAIN);
switch(rarg->eltype)
	{
	case BOOL: case SINT: case INTG:
		{
		ARRAY *tmp;
		register unsigned bnd;
		register int (*access)(), i;
		register unsigned char *cp;
		register unsigned *base;
		unsigned shape, arraybound();
		int (*initdint())();

		shape = arraybound(rarg);
		tmp = mkarray(CHAR, 1, &shape);
		base = (unsigned *)arraystart(rarg);
		bnd = shape;
		cp = (unsigned char *)arraystart(tmp);
		access = initdint(rarg);
		while(bnd--)
			{
			cp[bnd] = i = (*access)(base, bnd);
			if(i < -255 || i > 255)
				{
				freearray(tmp);
				prt_error("not a byte",DOMAIN);
				}
			}
		freearray(rarg);
		rarg = tmp;
		(*(printer == -1 ? pwrite : out_printer))((unsigned char *)cp, shape);
		fflush(device);
		break;
		}
	default:
		prt_error("not integer",DOMAIN);
	}
}
			
static void finish()
{
o_finish();	// note that device should have been the only one used 
closedevice();
closefont();
}

static void prt_error(             s,     n)
                      unsigned char *s; int n;
{
unsigned char buf[256];

sprintf(buf, "prt %s error, location %d\n", s, n);
write(2, buf, strlen(buf));
#ifdef	DOS
{
int	i;
for(i = 0; i < 1000000; ++i)	// busy-wait-for message to be read 
	;
}
#endif	// DOS 
error(n);
longjmp(errbuff, 1); // try again 
}

static void args(       rarg)
                 ARRAY *rarg;
{
ARRAY **arg = (ARRAY **)&rarg->shape[1];

if(rarg->eltype != PNTR)	{prt_error("not nested",DOMAIN); return;}
if(rarg->rank != 1)		{prt_error("not vector",RANK); return;}
if(rarg->shape[0] != 3)		{prt_error("not 3 elts",LENGTH); return;}
setaplt1(*arg++);
setfont(*arg++);
setdevice(*arg++);
}

static FILE *nt_fopen(const char *filename, const char *mode)
	{			// ensure we dont get file descriptor 0
	int fd = sopen
		(
		"NUL"
	,	O_RDWR | O_NOINHERIT | O_CREAT
	,	SH_DENYNO
	,	S_IRWXU | S_IRWXG | S_IRWXO
		);
	FILE *file = fopen(filename, mode);

	close(fd);
	return file;
	}

static void setdevice(       rarg)
                      ARRAY *rarg;
{
unsigned bnd = rarg->shape[0];
unsigned char *ip = (unsigned char *)&rarg->shape[1];	// input in QuadAV 
unsigned char *op = (unsigned char *)&rarg->shape[0];	// output in ASCII 
unsigned char * filename = (unsigned char *)op;
FILE *tmp;

closedevice();			// clear out any existing definition 

if(rarg->rank != 1)		{prt_error("not vector",RANK); return;}
if(rarg->eltype != CHAR)	{prt_error("not character",DOMAIN); return;}
if(!bnd)
#if	defined(DOS)
	filename = "lpt1";
#elif	defined(WATCOM)
	{prt_error("must not be null", DOMAIN); return;}
#else	// defined(DOS) 
	{
	device = stdout;
	return;
	}
#endif	// defined(DOS) 
else
	{
	while(bnd--)switch(*op++ = avtounix(*ip++))
		{
	case SQUISH:		prt_error("invalid character",DOMAIN); return;
		}
	*op = 0;
	}
if
	(
#if	defined(DOS)
	tmp = fopen(filename,"wb")
#elif	defined(WATCOM)
	tmp = nt_fopen(filename,"wb")
#else//  
	tmp = popen(filename,"w")
#endif	// defined(DOS) 
	)
	device = tmp;
else				{prt_error("can't open file",DOMAIN); return;}

// which printer are we talking to - if any ? 

printer = -1;			// assume not a printer 
#if	defined(DOS)
	for(op = (unsigned char *)filename; *op ; ++op) // force lower case 
		if(*op >= 'A' && *op <= 'Z') *op += 'a' - 'A';
	if(!strcmp(filename,"prn"))  printer = 0;
	if(!strcmp(filename,"lpt1")) printer = 0;
	if(!strcmp(filename,"lpt2")) printer = 1;
	if(!strcmp(filename,"lpt3")) printer = 2;
	if(!strcmp(filename,"lpt4")) printer = 3;
#endif	// defined(DOS) 
}

static void closedevice()
{
if
	(
	device
#if	defined(DOS)
#elif	defined(WINDOWS3)
#else//  
	&& stdout != device
	&& -1 == pclose(device)
#endif	// DOS 
	)
	fclose(device);
device = 0;
}

static void setfont(       rarg)
                    ARRAY *rarg;
{
unsigned bnd = rarg->shape[0];
unsigned char *ip = (unsigned char *)&rarg->shape[1];	// input in QuadAV 
unsigned char *op = (unsigned char *)&rarg->shape[0];	// output in ASCII 
unsigned char * filename = (unsigned char *)op;
FILE *tmp;

closefont();
if(rarg->rank != 1)		{prt_error("not vector",RANK); return;}
if(rarg->eltype != CHAR)	{prt_error("not character",DOMAIN); return;}
if(!bnd) return;
while(bnd--)switch(*op++ = avtounix(*ip++))
	{
case SQUISH:			prt_error("invalid character",DOMAIN); return;
	}
*op = 0;
if(tmp = fopen(f_fname(filename), "rb")) font = tmp;
else				{prt_error("can't open file",DOMAIN); return;}
}

static void closefont()
{
if(font)
	{
	fclose(font);
	font = 0;
	}
}

static void setaplt1(       rarg)
                     ARRAY *rarg;
{
unsigned bnd = rarg->shape[0];
unsigned char *ip = (unsigned char *)&rarg->shape[1];	// input in QuadAV 
unsigned char *op = (unsigned char *)&rarg->shape[0];	// output in ASCII 
unsigned char * filename = (unsigned char *)op;
static unsigned char buf[256];

aplt1 = 0;			// clear any previous setting		

if(rarg->rank != 1)		{prt_error("not vector",RANK); return;}
if(rarg->eltype != CHAR)	{prt_error("not character",DOMAIN); return;}
if(!bnd) return;
while(bnd--)switch(*op++ = avtounix(*ip++))
	{
case SQUISH:			prt_error("invalid character",DOMAIN); return;
	}
*op = 0;
strncpy(buf, filename, sizeof(buf));
buf[sizeof(buf)-1] = 0;
aplt1 = buf;
}

static void downloadfont()
{
unsigned char buf[16*1024];
unsigned fontlen;
unsigned written;
int (*out_fn)() = printer == -1 ? pwrite : out_printer;

for(; fontlen = fread(buf, 1, sizeof(buf), font);)
	{
	written = (*out_fn)(buf, fontlen);
	if(fontlen != written)
		{prt_error("font download failed", written); return;}
	}
closefont();
fflush(device);
}

static unsigned char * prt_getenv(              envname)
                                unsigned char * envname;
{
if
	(
	device &&
	0 == strncmp("APLT", envname, 4) &&
	'0' <= envname[4] &&
	'9' >= envname[4]
	) return aplt1;
return 0;
}

static unsigned char * f_fname(              name)
                             unsigned char * name;
{
static unsigned char buf[256];

strcpy(buf, name);	// take a copy 
	{
	unsigned len = strlen(name);
	unsigned char * tok = (unsigned char *)strtok(buf, "/\\:");
	
	if(len == strlen(tok))	// relative path name 
		{
		strcpy(buf, getenv("DYALOG"));
		strcat(buf, "/fonts/");
		}
	else
		buf[0] = 0;
	}
strcat(buf, name);
strcat(buf, fextend(buf, ".FNT"));
return buf;
}

static void prt_tr_error(    err_code)
                         int err_code;
{				// catch translate table errors 
extern int test_file;

test_file = -1;
error(PRT_ERRBASE + err_code);
}

#if	defined(DOS)
#	undef	H	// clash msdos.cf vs quadav.h 
#	undef	L	// clash msdos.cf vs quadav.h 
#	undef	R	// clash msdos.cf vs quadav.h 
static int out_printer(unsigned char *buf, unsigned count)
{
unsigned sent = 0;

for (; sent < count; ++sent)
	{
	Registers.AX.LH.H = 0;
	Registers.AX.LH.L = buf[sent];
	Registers.DX.R = printer;
	callint(0x17);
	if((Registers.AX.LH.H & 0x29) && out_fail)
		(*out_fail)();
	}
return sent;
}
#else	// defined(DOS) 
static int out_printer( unsigned char *buf, unsigned count)
{
	return 0;
}
#endif	// defined(DOS) 

#ifdef XAPL
syserror(         n)	// to support code starting X window system parts 
         unsigned n;
{
	unsigned char buff[30];
	sprintf(buff, "prt : syserror %u\n", n);
	write(2, buff, strlen(buff));
	exit(0);
}
#endif // XAPL 
