
//	Copyright (c) 1982 Dyadic Systems Limited	

/*
	Terminal control for 
	basic version 7				( V7 )
	system III and V			( BELL III)
	berkley 4.1 and 4.2			( bsd4.x )

*/

#include <machine.h>
#include <stdio.h>
#include <stdlib.h>

#if	defined(FORTUNE)
#	define	BSD		// cntl o is used for flush 
#elif	defined(SUN)
#	define BELL
#elif	defined(PYRAMID)
#	define	BELL	// get BELL terminal driver in preference to BSD 
#	undef	BSD
#endif

#if	!(defined(PYRAMID) || defined(HP9000) || defined(DOS) || defined(WATCOM))
#	include <sys/ioctl.h>
#endif

#ifdef	DS90
#include <sys/types.h>	// to get uchar_t typedef   
#define	C_CC	c_ccs
#else//  
#define	C_CC	c_cc
#endif	// DS90 

#ifdef	BELL

#include <termio.h>					// III 
#include <termios.h>					// III 
typedef struct termios TTY;
#define DYALOG_TCGET	TCGETS
#define DYALOG_TCSET	TCSETSW

#ifndef TIMEOV
#define TIMEOV 3
#endif	// TIMEOV 

#else	//~BELL 
#if	defined(DOS) || defined(WATCOM)
	typedef struct {unsigned bufferd;} TTY;
#else	//~DOS 

#include <sgtty.h>				// V7	bsd4.x	
typedef struct					// V7	bsd4.x	
	{					// V7	bsd4.x	
	 struct sgttyb sg;			// V7	bsd4.x	
	 struct tchars tchar;			// V7	bsd4.x	
#ifdef BSD
	 struct ltchars ltchar;			//	bsd4.x	
#endif // BSD 
	} TTY;					// V7	bsd4.x	
#endif	// DOS 

#endif	// BELL 

static TTY	ttycontext,	// as we arrived			
		ttyapl,		// apl output mode			
		ttycbreak,	// apl input mode			
		ttyap,		// for aps (output tabs cr, lf)		
		ttyaout;	// almost raw - apl arbout, arbin mode	



unsigned	echo,		// were we echoing on startup	
		tabson;		// are hard tabs turned on ?	
short		ospeed;		// output speed for termcap	
int		piped;		// multi-way flag:		
				//	0	stdin is tty	
				//	+ve	fd for /dev/tty	
				// 	-1	no tty at all	

extern char *ttyname();
static	char my_ttyname[32] = "";

#ifdef	INTERRUPTS
unsigned char tty_weak, tty_strong; // to communicate with input map setup 
#endif	// INTERRUPTS 

int ismytty(fd)
int fd;
{
	char *name = ttyname(fd);

	return name && 0 == strcmp(my_ttyname, name);
}

inittty()
{
	static int trystream[] = { 0, 2, 1, -1 };
	register int fd, i = 0;

	while((fd = trystream[i++]) >= 0)	// try to find a tty	
		 if(is_user_io(fd))
			break;			// bingo!		

	if(piped = fd)				// stdin is not a tty	
	{
		echo = 1;			// then we want echo	
		if(fd < 0)			// no tty found yet	
#if	!defined(WATCOM)
			if((fd = open("/dev/tty", 0)) < 0)
#endif//!defined(WATCOM)
				return;		// no terminal attached	
	}

	{
		char *name = ttyname(fd);

		if(name)strcpy(my_ttyname, name);
	}

#ifdef BELL

	ioctl(fd, DYALOG_TCGET, &ttycontext);
	ttyapl = ttycontext;
	if(piped == -1)
		close(fd);
	else
	{
	 echo = ECHO == (ttyapl.c_lflag&ECHO);	// echo set ?		
	 ospeed = ttyapl.c_cflag;		// get ospeed for termcap 
	 tabson = TAB3 != (ttyapl.c_oflag&TAB3);// output tabs on ?	
	 ttyapl.c_lflag &= ~ECHO;		// echo off		
	 ttyapl.c_lflag &= ~ICANON;		// not a line at a time	
	 ttyapl.c_iflag &= ~ISTRIP;		// ensure 8 bits	
						// keyboard stuff strips 
#ifdef SUN
	// some sun terminals have probs with our preference for 8 data bits 
	{
		unsigned char *aplbits;

		aplbits = (void *)getenv("APLBITS");	// APLBITS env var	
		if (
			aplbits &&		// var is set and ...	
			*aplbits == '7'		// has value 7		
		)
			ttyapl.c_iflag |= ISTRIP;	// set ISTRIP	
	}
#endif // SUN 

#ifdef	INTERRUPTS
	 if(tty_weak)				// has been specified?  
		ttyapl.C_CC[0] = tty_weak;	// set weak intr char	
	 if(tty_strong)
		ttyapl.C_CC[1] = tty_strong;	// set strong intr char	
#endif	// INTERRUPTS 

	memset					// get back most ^ chars
		(
		ttyapl.C_CC + VEOF
	,	0
	,	NCCS - VEOF
		);
	 ttyapl.C_CC[VEOF] = 1;			// one char at a time	
	 ttyapl.C_CC[VEOL] = TIMEOV;		// time out value	
	 ttyapl.c_iflag &= ~(INLCR|IGNCR|ICRNL);// true tabs, separate CR LF 
	}

	ttycbreak = ttyapl;
	ttyap = ttycbreak;
	ttyap.c_oflag &= ~(TABDLY|ONLCR|OCRNL);// true tabs, separate CR LF 
	ttyaout = ttyap;
	ttyaout.c_lflag &= ~ISIG;		// disable interrupts	

#else	//~BELL 
#if	defined(DOS) || defined(WATCOM)
	echo = 1;
#else	//~DOS 

	ioctl(fd, TIOCGETP, &ttycontext.sg);
	ioctl(fd, TIOCGETC, &ttycontext.tchar);

#ifdef	BSD
	ioctl(fd, TIOCGLTC, &ttycontext.ltchar);		// BSD4.x 
	ttyapl = ttycontext;					// BSD4.x 
	ttyapl.ltchar.t_suspc  = -1;	/* we want cntl z */	/* BSD4.x */
	ttyapl.ltchar.t_dsuspc = -1;	/* we want cntl y */	/* BSD4.x */
	ttyapl.ltchar.t_rprntc = -1;	/* for completeness*/	/* BSD4.x */
	ttyapl.ltchar.t_werasc = -1;	/* we want cntl w */	/* BSD4.x */
	ttyapl.ltchar.t_lnextc = -1;	/* we want cntl v */	/* BSD4.x */
	ttyapl.ltchar.t_flushc = -1;	/* we want cntl o */	/* BSD4.x */
#else	//~BSD 
	ttyapl = ttycontext;
#endif	// BSD 

	if(piped == -1)
		close(fd);
	ospeed = ttyapl.sg.sg_ospeed;
#ifdef	INTERRUPTS
	if(tty_weak)				// has been specified?  
		ttyapl.??? = tty_weak;	// set weak intr char	
	if(tty_strong)
		ttyapl.??? = tty_strong;	// set strong intr char	
#endif	// INTERRUPTS 
	
	i = ttyapl.sg.sg_flags;

	if(piped == 0)
	{
		echo = ECHO == (i&ECHO);
		tabson = XTABS != (i&XTABS);
		i &= ~ECHO;		//	turn off echo		
		ttyapl.sg.sg_flags = i;
	}

	i &= ~XTABS;			//	turn on true tabs	
	i &= ~CRMOD;			//	separate linefeed and cr
	i |= CBREAK;			//	turn on cbreak		
	ttycbreak = ttyapl;
	ttycbreak.sg.sg_flags = i;
	ttyaout = ttyap = ttycbreak;
	ttycbreak.sg.sg_erase = -1;	// no erase character for PERQ	

#endif	// DOS 
#endif	// BELL 
}

termcbreak()
{
term(&ttycbreak);
}

termap(pipe)
register int pipe;
{
force(&ttyap,pipe);
}

termaout(pipe)
register int pipe;
{
force(&ttyaout,pipe);
}

forceapl(pipe)
register int pipe;
{
force(&ttycontext,pipe);	// reset it for sure 
termapl();			// reset it if input is from a terminal 
}

termapl()
{
term(&ttyapl);
}

termcontext()
{
term(&ttycontext);
}

static term(tty)
register TTY *tty;
{
#if	! (GUI || 1 == _CONSOLE)
	switch(piped)
	{
	case -1:			// no tty attached anywhere	
		return;
	case 0:				// stdin is a tty		
		force(tty, 0);
	default:			// 'piped' is an fd for the tty	
		break;
	}
#endif//! (GUI || 1 == _CONSOLE)
}

static force(tty,pipe)
register TTY *tty;
register int pipe;
{
#if	! (GUI || 1 == _CONSOLE)

#ifdef	BELL

ioctl(pipe,DYALOG_TCSET,tty);					// III 

#else	//~BELL 
#if	!(defined(DOS) || defined(WATCOM))

ioctl(pipe,TIOCSETN,&tty->sg);			// V7	bsd4.x	
ioctl(pipe,TIOCSETC,&tty->tchar);		// V7	bsd4.x	

#ifdef	BSD
ioctl(pipe,TIOCSLTC,&tty->ltchar);		//	bsd4.x	
#endif	// BSD 


#endif	// DOS 
#endif	// BELL 

#endif//! (GUI || 1 == _CONSOLE)
}

//	Copyright (c) 1982 Dyadic Systems Limited	

