//	Copyright (c) 1982 Dyadic Systems Limited	

#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#undef	BUFSIZ
#include <apl.h>
#include <support.h>
#include <quadav.h>
#include <assert.h>
#undef	getenv

unsigned char taskid[] = "xutils";

#define	VERSION	"8.2"
#define	REG	register
#define	UNS	unsigned
#define	UCHAR	unsigned char

extern ARRAY	*avx(),
		*box(),
#ifdef	DOS
		*copyseg(),
		*interrupt(),
		*port(),
#endif	// DOS 
#if	defined(WATCOM)
		*gtenv(),
#endif//defined(WATCOM)
		*hex(),
		*ltom(),
		*ltov(),
		*mtol(),
		*dbr(),
		*ss(),
		*vtol();

static struct FUNCTION	
	{unsigned char	*f_name;
	UNS	f_syntax;
	ARRAY	*(*f_pointer)();
	} functions[] =
		{
		"avx",		RSLT|MONA,	avx,
		"box",		RSLT|OPTL,	box,
#ifdef	DOS
		"copyseg",	SHYR|OPTL,	copyseg,
		"interrupt",	SHYR|OPTL,	interrupt,
		"port",		SHYR|OPTL,	port,
#endif	// DOS 
#if	defined(WATCOM)
		"getenv",	RSLT|MONA,	gtenv,
#endif//defined(WATCOM)
		"hex",		RSLT|MONA,	hex,
		"ltom",		RSLT|OPTL,	ltom,
		"ltov",		RSLT|OPTL,	ltov,
		"mtol",		RSLT|OPTL,	mtol,
		"dbr",		RSLT|MONA,	dbr,
		"ss",		RSLT|OPTL,	ss,
		"vtol",		RSLT|OPTL,	vtol,
		};

#define		NFUNCTIONS  (sizeof(functions)/sizeof(struct FUNCTION))

ARRAY **Larg;	/* Global pointer so that OPTL larg functions can create
		 * one which will be freed.
		 */

ARRAY **Rarg;	/* Global pointer so that coercions can occur and still be
		 * freed.
		 */

ARRAY **Rslt;	/* Global pointer so that local results can be created and
		 * still freed if an error occurs
		 */

#if	defined(DOS)
	main()
#elif	defined(WATCOM)
	win_main(int argc, unsigned char *argv[])
#else
	main(argc, argv)
	int	argc;
	unsigned char	*argv[];
#endif	// DOS 
{
	ARRAY	*getarray(), *freearray(), *(*f)();
	ARRAY	*larg, *rarg, *rslt;
	UNS	s, i, fromapl();
	int	fncode;

#if	defined(DOS)
	initxutils();
#else
	initxutils(argc, argv);

#endif	// DOS 
	larg = rarg = rslt = 0;

	Larg = &larg; Rarg = &rarg; Rslt = &rslt;

	setjmp(errbuff);		// come here after error 
	for(;;)
		{
		larg = freearray(*Larg);
		rarg = freearray(*Rarg);
		rslt = freearray(*Rslt);

		fncode = i = fromapl();
		if(-1 == fncode)	// APL request termination 
			{
			toapl(0);	// return control to APL 
			fromapl();	// on DOS we dont get this back 
			exit(0);	// on UNIX we do and we exit 
			}
		if(i >= NFUNCTIONS) syserr("main");
		s = functions[i].f_syntax;
		f = functions[i].f_pointer;
		switch(s & DYAD)
			{case DYAD:	// dyadic and optional	
					larg = getarray();
					rarg = getarray();
					rslt = (*f)(larg,rarg);
					break;
			case MONA:	// monadic 
					rarg = getarray();
					rslt = (*f)(rarg);
					break;
			default:	// niladic 
					rslt = (*f)();
			}

		if(s & RSLT)
			{
			putarray(rslt);
			}
		}
}

/*	s y s e r r
	print syserr with (optional) message and die
*/
syserr(msg)
unsigned char	*msg;
{
	printf("xutils sys err%s %s\n", *msg ? ": " : "", msg);
	exit(1);
}

/*	i n i t x u t i l s
	define named functions or ALL if none named
*/
#if	defined(DOS)
static	initxutils()
#else
static	initxutils(argc, argv)
int	argc;
unsigned char	*argv[];
#endif	// DOS 
{
	REG 	i;
	REG unsigned char *arg;
	int	nfns;
	unsigned char	wanted[NFUNCTIONS];

	// preset functions requested flags	
	for(i=0; i<NFUNCTIONS; i++) wanted[i]=0;

	// count and identify each function named in arguments	
	nfns = 0;
#if	defined(DOS)	// I dont support args to APs under DOS 
#else
	while(argc--)
		{arg = *(argv++);
		for(i=0; i<NFUNCTIONS; i++)
			{if(wanted[i]) continue;
			if(!strcmp(arg,functions[i].f_name)) break;
			}
		if(i<NFUNCTIONS)
			{wanted[i] = 1;
			nfns++;
			}
		else if(strcmp(arg,"xutils") && strcmp(arg,""))
			printf("xutils %s not found %s\n",
				VERSION, arg);
		}
		
#endif	// DOS 
	// define requested functions, or ALL if none requested	
	startup(nfns?nfns:NFUNCTIONS);
	for(i=0; i<NFUNCTIONS; i++)
		if(nfns==0 || wanted[i])
			define(functions[i].f_name, functions[i].f_syntax, i);
}

/*	b l o c k m o v e
	character block move
*/
blockmove(from, to, nchars)
REG UCHAR	*from, *to;
REG UNS		nchars;
{
	while(nchars--) *to++ = *from++;
}

/*	a v x
	return 0-origin index in quad av of simple text
*/

ARRAY	*avx(rarg)
ARRAY	*rarg;
{
	REG UCHAR	*cp, *cpend;
	REG UNS		*ip;
	UCHAR		*cpstart;
	ARRAY		*rslt;

	if(rarg->eltype != CHAR) error(DOMAIN);
	cpstart = (UCHAR *)arraystart(rarg);
	cpend = cpstart + arraybound(rarg);

	// if all characters are 127 or less can return SINT	

	for(cp=cpstart; cp<cpend; cp++) if( *cp & 128 ) break;
	if(cp==cpend)
		{rarg->eltype = SINT;
		return rarg;
		}
	rslt = mkarray(DINT,rarg->rank,rarg->shape);

	ip = (UNS *) arraystart(rslt);
	for(cp=cpstart; cp<cpend; cp++) *ip++ = *cp & 0377;
	return rslt;
}

/*	h e x
	display object in hex
*/

static unsigned char	hexdigs[] = "0123456789ABCDEF";
static unsigned char	*hexdest;
static UNS	counter;

ARRAY *hex(rarg)
ARRAY *rarg;
{
	ARRAY	*rslt;
	UNS	shape;
	void	hexrslt(), hexcount(); 

	counter = 0;
	traverse(rarg,hexcount,0);
	shape = counter - 1;		// dont need trailing delimiter 
	rslt = mkarray(CHAR,1,&shape);
	hexdest = (unsigned char*)(rslt->shape + 1);
	traverse(rarg,hexrslt,0);
	return rslt;
}

void hexcount(array,depth)
ARRAY *array;
UNS depth;
{
	counter += array->length * (
		2			// two hex digits per byte   
		* sizeof(int)		// number of bytes per word  
		+ 1			// delimiter after each word 
	);
}

void hexrslt(array,depth)
ARRAY *array;
UNS depth;
{
	REG bound, indx;
	REG unsigned char *hexsrce;
	REG UCHAR byte;

	bound = array->length * sizeof(int);	// number of chars in array 
	hexsrce = (unsigned char*)array;		// first word of array      
	if (depth) *hexdest++ = NEWLINE;	// newline before sub-array 
	for (indx = 0; indx<bound; indx++){
		if (
			indx &&			// ... its not the first one 
			0 == indx%sizeof(int)	// and its a word boundary   
		) *hexdest++ = SP;		// 	leave a gap	     
		byte = *hexsrce++;		// get target byte	     
		*hexdest++ = hexdigs[byte>>4];	// format first hex digit    
		*hexdest++ = hexdigs[byte&0xf];	// format second hex digit   
	}
}

traverse(array,func,depth)  // tramp (possibly nested) array and apply func 
ARRAY *array;
void (*func)();
UNS depth;	// depth of recursion 
{
	REG UNS indx, bound;

	(*func)(array,depth);
	switch (array->type){
	case SIMPLE:
		break;

	case NESTED:
		bound = array->length - 2;
		for (indx = array->rank; indx < bound ; indx++)
			traverse((ARRAY *)array->shape[indx],func,depth+1);
		break;
	default:
		error(NONCE);
	}
}

/*	d b r
	remove leading, trailing, and multiple blanks
*/
ARRAY	*dbr(rarg)	
ARRAY	*rarg;
{
	REG UCHAR *iptr, *optr;
	REG 	c, nelts, last, begun;
	UCHAR	*base;

	if(rarg->type != SIMPLE) error(DOMAIN);
	if(rarg->eltype != CHAR) error(DOMAIN);
	if(! rarg->rank) return rarg;
	if(rarg->rank != 1) error(RANK);
	last = SP;
	begun = 0;
	base = optr = iptr = (UCHAR *)arraystart(rarg);
	for(nelts = rarg->shape[0]; nelts--;)
		{c = *iptr++;
		if(begun)
			{if(c != SP || last != SP)
				{*optr++ = last;
				last = c;
				}
			}
		else if(c != SP)
			{begun = 1;
			last = c;
			}
		}
	if(last != SP) *optr++ = last;

	nelts = rarg->shape[0] = optr-base;
	rarg->length = (nelts+sizeof(ARRAY)+sizeof(int)-1)/sizeof(int);
	return rarg;
}

/*
 *	s s
 *	
 *	regular expression matching string search and substitution function.
 *
 */

#define		INIT		REG UCHAR	*sp = (UCHAR *)instring;
#define		GETC()		(*sp++)
#define		PEEKC()		(*sp)
#define		UNGETC(c)	(--sp)
#define		RETURN(c)	return;
#define		ERROR(c)	regerr(c)

#include	<regexpav.h>

#define BUFSIZ	1024

ARRAY	*ss(larg, rarg)
ARRAY	*larg, *rarg;
{

	REG UCHAR	*ptr1, *ptr2;
	REG ARRAY	*arg;
	UCHAR		*doreplace(), *zmalloc();
	UCHAR		expbuf[BUFSIZ], *cbase, *rbase;
	UCHAR		replace, caseless, boolrslt;
	UNS		num, num2, matches;
	ARRAY		**argptr, *rslt;


	//	check args	
	if(rarg->eltype != PNTR) error(DOMAIN);
	if(rarg->rank != 1)	 error(RANK);
	if(rarg->shape[0] <2 || rarg->shape[0] >3) error(LENGTH);
	replace = rarg->shape[0] == 3;
	caseless = boolrslt = 0;
	if(larg)
		{
		if(larg->rank > 1) error(RANK);
		if(arraybound(larg) <1 || arraybound(larg) >2) error(LENGTH);
		if(!larg->rank)	// scalar could be BOOL or SINT	
			switch(larg->eltype)
				{
			case BOOL:
				caseless = 0 != (0x80 & *arraystart(larg));
				break;
			case SINT:
				if(1< *arraystart(larg)) error(DOMAIN);
				caseless = *arraystart(larg);
				break;
			default  :
				error(DOMAIN);
				}
		else		// vectors always squeezed	
			{
			if(larg->eltype != BOOL) error(DOMAIN);
			caseless = 0 != (0x80 & *arraystart(larg));
			if(larg->shape[0] == 2)
				boolrslt = 0 != (0x40 & *arraystart(larg));
			}
		}

	// check rarg[1] 
	argptr = (ARRAY **)arraystart(rarg);
	rslt = *argptr++;
	ckchv(rslt);

	cbase = ptr1 = (UCHAR *)arraystart(rslt);
	num = arraybound(rslt);
	if(!replace)	// copy the text so can use original array as bool 
		{
		rbase = ptr1;
		cbase = ptr1 = zmalloc(num);
		ncp(cbase, rbase, num);
		}

	// check rarg[2] (the regular expression) 
	arg = *argptr++;
	ckchv(arg);
	ptr2 = (UCHAR *)arraystart(arg);
	num2 = arraybound(arg);

	if(replace)
		{
		arg = *argptr;
		ckchv(arg);
		doreplace((UCHAR*)0, (UCHAR*)arg, (UNS*)0);
		}

	compile(ptr2, expbuf, expbuf+BUFSIZ, num2, caseless);

	if(!replace)
		{
		rslt->eltype = SINT;
		zero(rbase, rbase+num);
		matches = 0;
		}

	arg = (ARRAY *)(ptr1+num-1);
	lpstart = ptr1;  /* put back in to fix bug 8084 */

	if(step(ptr1, (UCHAR *)arg, expbuf)) for(;;)
		{
		UCHAR *last_ptr1 = ptr1, *last_loc1 = loc1;
		unsigned again =
			step(ptr1 = loc2, (UCHAR *)arg, expbuf) && !circf;

		if(again && loc1 == last_loc1) break;	// bug 1781 
		if(!replace)
			{
			(*(rbase+(last_loc1-cbase)))++;
			matches++;
			}
		else
			doreplace(last_ptr1, last_loc1, (UNS *)0);
		if(!again)
			break;
		}
	if(!replace)
		{
	if(!boolrslt) 
		if(!matches)
			rslt = mkarray(SINT, 1, &matches);
		else
			{
			REG UNS		indx;
			REG long	*lptr;

			ptr2 = rbase;
			lptr= (long*)arraystart(rslt=mkarray(LONG,1,&matches));
			indx = 1;
			while(matches--)
				{
				while(!*ptr2++) indx++;
				*lptr++ = indx++;
				}
			}
		}
	else
		{				// copy the tail	
		UNS tail = num - (ptr1-cbase);

		if( (int)tail < 0 )
			tail = 0;
		ptr2 = doreplace(cbase, (UCHAR *)0, &matches); // query	
		num = matches + tail;
		rbase = (UCHAR *)arraystart(rslt = mkarray(CHAR, 1, &num));
		ncp(rbase, ptr2, matches);
		ncp(rbase+matches, ptr1, tail);
		free(ptr2);	// Bugfix 8/7/87 - free up working space. 
		}
	if(!replace)
		free(cbase);
	return rslt;
}

ckchv(array)
REG ARRAY	*array;
{
	if(array->eltype != CHAR) error(DOMAIN);
	if(array->rank > 1) error(RANK);
}

ncp(to, from, num)
REG UCHAR	*to, *from;
REG UNS		num;
{
	while(num--)
		*to++ = *from++;
}

zero(cptr1, cptr2)
REG UCHAR	*cptr1, *cptr2;
{
	for( ;cptr1<cptr2;*cptr1++ = 0);
}

UCHAR	*doreplace(cptr1, cptr2, unsptr)
REG UCHAR	*cptr1, *cptr2;
UNS		*unsptr;

{
		UCHAR		*zmalloc(), *zrealloc();

	static	UCHAR	*dataptr, *fromptr, *cptr;
	static	UNS	numels;
	static	UNS	bufsize = BUFSIZ;

	if(!cptr1)	// initialise - cptr2 is ptr to rarg[3]	
		{
		fromptr = (UCHAR *)arraystart((ARRAY *)cptr2);
		numels  = arraybound((ARRAY *)cptr2);
		dataptr = cptr = zmalloc(bufsize);
		return 0;
		}
	else if(!cptr2)	// query - return dataptr, numused through unsptr 
		{
		*unsptr = cptr - dataptr;
		return dataptr;
		}
	while(bufsize < cptr - dataptr + numels + cptr2 - cptr1)
	//  Bugfix 20/11/87 - repeat until bufsize large enough  
		{
		UNS ptrpos;

		ptrpos = cptr - dataptr;
		dataptr = zrealloc(dataptr, bufsize += BUFSIZ);
		cptr = dataptr + ptrpos;
		}
	while(cptr1 < cptr2) *cptr++ = *cptr1++;
	for	(cptr1 = fromptr, cptr2 = fromptr+numels;
		cptr1 < cptr2;
		*cptr++ = *cptr1++
		);
	return 0;
}

/*	r e g e r r 
	return regular expression error to apl
*/

regerr(c)
REG UCHAR	c;
{
	REG err;

	switch(c)
		{
	case 11:			// Range endpoint too large	
	case 43:			// Too many \(			
	case 50: error(LIMIT);		// Regular expression overflow	
	case 16: err = 0; break;	// Bad number			
	case 25: err = 1; break;	// "\digit" out of range	
	case 36: err = 2; break;	// Illegal or missing delimiter	
	case 41: err = 3; break;	// No remembered search string	
	case 42: err = 4; break;	// \( \) imbalance		
	case 44: err = 5; break;	// More than 2 numbers in \{ \}	
	case 45: err = 6; break;	// } expected after \.
	case 46: err = 7; break;	// 1st no. > 2nd in \{ \}	
	case 49: err = 8; break;	// [ ] imbalance		
		}
	error(XUT_ERRBASE + err);
}

/*	d e l i m i t e r
	return the character in an optional singleton array
*/
static UCHAR	delimiter(array)
ARRAY		*array;
{
	if(0==array)	return NEWLINE;
	if(array->eltype != CHAR) error(DOMAIN);
	if(1!=arraybound(array)) error(LENGTH);
	return *(UCHAR *)arraystart(array);
}

/*	m k v e c t o r
	return pointer to a text vector with specified text in it
*/
static ARRAY	*mkvector(from, upto)
REG UCHAR	*from, *upto;
{
	ARRAY	*rslt;
	UNS	n;

	if(upto<from) syserr("mkvector");
	n = upto-from;
	rslt = mkarray(CHAR, 1, &n);
	blockmove(from, arraystart(rslt), n);
	return rslt;
}

/*	u m a x
	UNS max
*/
static UNS	umax(a,b)
UNS	a, b;
{
	return a>b ? a : b;
}

/*	l t o v
	linelist to vector of vectors
*/
ARRAY	*ltov(larg, rarg)
ARRAY	*larg, *rarg;
{
	REG UCHAR	*cp, delim, *cpstart, *cpend;
	ARRAY		*rslt, **vptr;
	UNS		ndelims;

	delim = delimiter(larg);
	if(rarg->eltype!=CHAR) error(DOMAIN);
	cpstart = (UCHAR *)arraystart(rarg);
	cpend = cpstart + arraybound(rarg);

	// count delimiters	
	ndelims = 0;
	if(cpend != cpstart)
		{for(cp=cpstart; cp<cpend; cp++) if(delim == *cp) ndelims++;
		if(delim != *--cp) ndelims++; // supply trailing delim	
		}
	rslt = mkarray(PNTR, 1, &ndelims);

	vptr = (ARRAY**) arraystart(rslt);
	if(ndelims)	// install each vector in turn	
		{for(cp=cpstart; cp<cpend; cp++)
			{if(delim != *cp) continue;
			*vptr++ = mkvector(cpstart, cp);
			cpstart = 1+cp;
			}
		if(delim != *--cp)
			*vptr = mkvector(cpstart, ++cp);
		}
	else *vptr = mkvector(cpstart,cpstart);	// prototype	
	return rslt;
}

/*	v t o l
	vector of vector to linelist
*/
ARRAY	*vtol(larg, rarg)
ARRAY	*larg, *rarg;
{
	REG ARRAY	**vp, **vstart, **vend;
	ARRAY		*rslt;
	UCHAR		*cp, delim;
	UNS		nchars;

	switch(rarg->eltype)
		{case CHAR:	return rarg;
		case PNTR:	break;
		default:	error(DOMAIN);
		}
	delim = delimiter(larg);
	vstart = (ARRAY**) arraystart(rarg);
	vend = vstart + arraybound(rarg);

	// count characters & check single level nested text	
	nchars = vend-vstart;
	for(vp=vstart; vp<vend; vp++)
		{if(CHAR!= (*vp)->eltype) error(DOMAIN);
		nchars += arraybound(*vp);
		}
	rslt = mkarray(CHAR, 1, &nchars);

	// copy in text, with trailing delimiter	
	cp = (UCHAR *)arraystart(rslt);
	for(vp=vstart; vp<vend; vp++)
		{nchars = arraybound(*vp);
		blockmove(arraystart(*vp), cp, nchars);
		cp+=nchars;
		*cp++ = delim;
		}

	return rslt;
}

/*	m t o l
	matrix to linelist with removal of trailing blanks
*/
ARRAY	*mtol(larg, rarg)
ARRAY	*larg, *rarg;
{
	REG UCHAR	*cp, *to, *rowstart;
	UCHAR		delim, *rsltbase;
	ARRAY		*rslt;
	UNS		ncols, nrows, n;

	delim = delimiter(larg);
	if(rarg->eltype!=CHAR) error(DOMAIN);
	nrows=ncols=1;
	if(rarg->rank)
		{
		n = rarg->rank;
		ncols = rarg->shape[--n];
		while(n)
			nrows *= rarg->shape[--n];
		}
	n = nrows*(1+ncols);
	rslt = mkarray(CHAR, 1, &n);
	cp = rsltbase = (UCHAR *)arraystart(rslt);

	for(rowstart=(UCHAR *)arraystart(rarg); nrows--; rowstart+=ncols)
		{to = rowstart+ncols;
		while(--to >= rowstart && SP== *to);
		n = (1+to)-rowstart;
		blockmove(rowstart, cp, n);
		cp += n;
		*cp++ = delim;
		}
	rslt->shape[0] = n = cp - rsltbase;
	rslt->length = (n+sizeof(ARRAY)+sizeof(int)-1)/sizeof(int);
	return rslt;
}

/*	l t o m
	linelist to matrix
*/
ARRAY	*ltom(larg, rarg)
ARRAY	*larg, *rarg;
{
	REG UCHAR	*cp, *rend, delim, *rstart, *last, *to;
	UNS		shape[2], n;
	ARRAY		*rslt;

	delim = delimiter(larg);
	if(rarg->eltype != CHAR) error(DOMAIN);
	rstart = (UCHAR *)arraystart(rarg);
	rend = rstart + arraybound(rarg);

	// count rows & longest line	
	shape[0]=shape[1]=0;
	for(last=cp=rstart; cp<rend; cp++)
		{if(delim != *cp) continue;
		shape[0]++;
		shape[1] = umax(shape[1], cp-last);
		last = 1+cp;
		}
	if(rstart!=rend && delim != *(cp-1))
		{shape[0]++;
		shape[1] = umax(shape[1], cp-last);
		}
	rslt = mkarray(CHAR, 2, shape);

	// copy in rows, with trailing spaces	
	to = (UCHAR *)arraystart(rslt);
	for(last=cp=rstart; cp<rend; cp++)
		{if(delim != *cp) continue;
		n = cp-last;
		makerow(last,to,shape[1],n);
		to += shape[1];
		last = 1+cp;
		}
	if(rstart!=rend && delim != *(cp-1)) makerow(last,to,shape[1],cp-last);

	return rslt;
}

/*	m a k e r o w 
	copy n chars padding to length with spaces
*/
makerow(from, to, length, n)
REG UCHAR	*from, *to;
REG UNS		length, n;
{
	length -= n;
	while(n--) *to++ = *from++;
	while(length--) *to++ = SP;
}

/*	b o x
	simulates quadbox function.
*/
	union	els
			{
			short	i;
			long	l;
			double	d;
			} fill, delim;
	union	points
			{
			UCHAR	*s;
			short	*i;
			long	*l;
			double	*d;
			} from, to;

	typedef void	SETFN(ARRAY *, UNS);
	typedef SETFN	*SETFNP;
	extern	SETFN	setintg, setlong, setdoub;
	typedef void	ADDFN(short);
	typedef ADDFN	*ADDFNP;
	extern	ADDFN	addintg, addlong, adddoub;
	typedef UNS	CMPFN(short, void *);
	typedef CMPFN	*CMPFNP;
	extern	CMPFN	cmpintg, cmplong, cmpdoub;

	SETFNP	setfns[] =
			{
			setintg, // not used 
			setintg, // not used 
			setintg, // not used 
			setintg,
			setlong,
			setdoub,
			};
	ADDFNP	addfns[] =
			{
			addintg, // not used 
			addintg, // not used 
			addintg, // not used 
			addintg,
			addlong,
			adddoub,
			};
	CMPFNP	cmpfns[] = 
			{
			cmpintg, // not used 
			cmpintg, // not used 
			cmpintg, // not used 
			cmpintg,
			cmplong,
			cmpdoub,
			};

ARRAY	*box(larg, rarg)
ARRAY	*larg, *rarg;
{
	REG UNS		i, rowels;
	REG UCHAR	*begrow;
	CMPFN		*cmp;
	ADDFN		*add;

	UCHAR	*k, *ptr;
	UNS	shape[2], rowsize, arrayend, elsize,
		sh0, sh1, rsh0, rel, rra, lel;
	ARRAY	*rslt, *cbox(), *templ, *tempr;

	extern ARRAY	*(*convfns[7][7])();

		//	check rank and data type	

	templ = tempr = 0;		// local temp arrayed must be freed  

	if((rel=rarg->eltype) == PNTR)
		error(DOMAIN);
	else if((rra=rarg->rank) >2)
		error(RANK);
	if(larg) 
		if((lel=larg->eltype) == PNTR)
			error(DOMAIN);
		else if(larg->rank > 1)
			error(RANK);
		else if( (i=arraybound(larg)) < 1 || i > 2)
			error(LENGTH);

	shape[0] = shape[1] = 0;

		//	special-case empty arrays	
	if(!arraybound(rarg))
		return mkarray(rel, (rra == 2 ? 1 : 2), shape);
		//	process left arg		
	if(larg)
		{
		if(lel > rel)	// coerce rarg to largtype 
			{
			tempr = (*convfns[rel][lel])(rarg);
			freearray(rarg);
			rarg = tempr;
			rel = lel;
			}
		else if(rel > lel)	// or vice versa	
			{
			templ = (*convfns[lel][rel])(larg);
			freearray(larg);
			larg = templ;
			lel = rel;
			}
		else if(rel == BOOL)	// if both BOOL change to SINTS	
			{
			templ = (*convfns[lel][SINT])(larg);
			freearray(larg);
			larg = templ;
			lel = SINT;
			tempr = (*convfns[BOOL][SINT])(rarg);
			freearray(rarg);
			rarg = tempr;
			rel = SINT;
			}
		}
	else	// if no larg but rarg is BOOL change it to SINT	
		if(rel == BOOL)
			{
			tempr = (*convfns[BOOL][SINT])(rarg);
			freearray(rarg);
			rarg = tempr;
			}

	if(rel < INTG) // fast version for chars & sints 
		if(larg && lel != rel)
			error(DOMAIN);	// Num/Char clash 
		else
		{
			rslt = cbox(larg, rarg, i);

			if (templ)
				freearray(templ);

			if (tempr)
				freearray(tempr);

			return rslt;
		}

	(*setfns[rel])(larg, i);
	add = addfns[rel];
	cmp = cmpfns[rel];
	rsh0 = rarg->shape[0];
	ptr = (UCHAR *)arraystart(rarg);
		
	
	switch(rra)
		{
	case 0:
	case 1:	//	rarg is vector - result is matrix	
		sh0 = 1; sh1 = rowels = 0;
		arrayend = (rra ? rsh0 : 1);
		from.s = ptr;
		for(i = 0;i<arrayend;(*add)(0),++i)
			if((*cmp)(1, 0))
				{
				++sh0;
				if(rowels > sh1) sh1 = rowels;
				rowels = 0;
				}
			else ++rowels;
		if(rowels > sh1) sh1 = rowels;
		shape[0] = sh0; shape[1] = sh1;
		to.s = (UCHAR *)arraystart(rslt= mkarray(rel, 2, shape));
		from.s = ptr;
		for(rowels = 1,i= 0; i<arrayend; ++i,(*add)(0), ++rowels)
			if((*cmp)(1, 0))
				{
				while(rowels++ <= sh1)
					(*add)(1);
				rowels = 0;
				}
			else	(*add)(2);
		while(rowels++ <= sh1)
			(*add)(1);
		break;
	case 2:	//	rarg is a matrix - result is a vector	
		rowsize = (elsize = sizeel(rel)) * rarg->shape[1];

		begrow = ptr - elsize;		// 1. Get size of result 
		for(i = sh0 = 0;i < rsh0;++i)
		{
			k = begrow + rowsize;
			while (k > begrow)
			{
				if(!(*cmp)(2, k)) break;
				k -= elsize;
			}
			sh0 += (k - begrow) / elsize;
			if(i+1 != rsh0) sh0++;
			begrow += rowsize;
		}

		begrow = ptr - elsize;		// 2. Build result 
		to.s = (UCHAR *)arraystart(rslt = mkarray(rel, 1, &sh0));
		for(i = 0; i < rsh0; ++i)
		{
			k = begrow + rowsize;
			while (k > begrow)
			{
				if(!(*cmp)(2, k)) break;
				k -= elsize;
			}
			for(ptr=begrow + elsize ; ptr < k+elsize;)
				*to.s++ = *ptr++;
			if(i+1 != rsh0)
				(*add)(3);
			begrow += rowsize;
		}	
		}

	if (templ)
		freearray(templ);

	if (tempr)
		freearray(tempr);

	return rslt;
}

/*	c b o x
	faster version of box - just for chars and sints.
	If delimiter and fill are both SP, then box must suppress multiple
	occurences.  So box box 'andy  andy   andy' becomes 'andy andy andy'
*/
ARRAY	*cbox(larg, rarg, bound)
ARRAY	*larg, *rarg;
UNS	bound;
{
	REG UCHAR	*to, *from, *begrow, fill, delim, *k;
	UCHAR		*ptr, *arrayend, csflg, special_case;
	REG UNS		i;
	UNS		shape[2], rowels, rowsize, sh0, sh1, rsh0;
	ARRAY		*rslt;
	static	UCHAR	prot[] = {'\0', SP};

	csflg = CHAR == rarg->eltype; // flag if it's char 
	delim = fill = prot[csflg];

	if(larg)
		{
		ptr = (UCHAR *)arraystart(larg);
		switch(bound)
			{
		case 2:
			fill = ptr[1];
		case 1:
			delim = ptr[0];
			}
		}
	
	special_case = (fill == SP) && (delim == SP);
	
	rsh0 = rarg->shape[0];
	ptr = (UCHAR *)arraystart(rarg);
	switch(rarg->rank)
		{
	case 0:
	case 1:	//	rarg is vector - result is matrix	
		sh0 = 1; sh1 = rowels = 0;
		from = ptr;
		arrayend = from + (rarg->rank ? rsh0 : 1);
		for(; from < arrayend; ++from)
			if(*from == delim)
				{
				++sh0;
				if(rowels > sh1) sh1 = rowels;
				rowels = 0;
				}
			else
				++rowels;
		if(rowels > sh1) sh1 = rowels;
		shape[0] = sh0; shape[1] = sh1;
		to= (UCHAR *)arraystart(rslt= mkarray(
						csflg?CHAR:SINT, 2, shape));
		from = ptr;
		for(rowels= 1; from < arrayend; ++from, ++rowels)
			if(*from == delim)
				{
				while(rowels++ <= sh1)
					*to++ = fill;
				rowels = 0;
				}
			else
				*to++ = *from;
		while(rowels++ <= sh1)
			*to++=fill;
		break;
	case 2:	//	rarg is a matrix - result is a vector	
		rowsize = rarg->shape[1];
		begrow = ptr - 1;
		for(i = sh0 = 0 ;i < rsh0 ;++i)
		{
			k = begrow + rowsize;
			while (k > begrow)
			{
				if (*k != fill) break;
				k--;
			}
			sh0 += k - begrow;
			/* Don't have delimiter if last row, or
			   if special case and at start of row */
			if (i+1 != rsh0)  
				if(!(k==begrow && special_case))
					sh0++;
			begrow += rowsize;
		}

		to = (UCHAR *)arraystart(rslt = mkarray
						(csflg?CHAR:SINT, 1, &sh0));
		begrow = ptr - 1;
		for(i = 0; i < rsh0; ++i)
		{
			k = begrow + rowsize;
			while (k > begrow)
			{
				if (*k != fill) break;
				k--;
			}
			for(ptr=begrow+1; ptr <=k;)
				*to++ = *ptr++;
			if(i+1 !=rsh0)
				if(!(k==begrow && special_case))
						*to++ = delim;
			begrow += rowsize;
		}
		}	// switch 
	return rslt;
}

/*	s e t   f u n c t i o n s
	initialise the fill and or delimiter elements depending
	on the type of box's larg.
*/

void	setintg(larg, lbnd)
ARRAY	*larg;
UNS	lbnd;
{
	REG short	*ptr;

	delim.i = fill.i = (short)0;
	if(larg)
		{
		ptr = (short *)arraystart(larg);
		switch(lbnd)
			{
		case 2: fill.i = ptr[1];
		case 1: delim.i = ptr[0];
			}
		}
}

void	setlong(larg, lbnd)
ARRAY	*larg;
UNS	lbnd;
{
	REG long	*ptr;

	delim.l = fill.l = (long)0;
	if(larg)
		{
		ptr = (long *)arraystart(larg);
		switch(lbnd)
			{
		case 2: fill.l = ptr[1];
		case 1: delim.l = ptr[0];
			}
		}
}

void	setdoub(larg, lbnd)
ARRAY	*larg;
UNS	lbnd;
{
	REGDOUB		*ptr;

	delim.d = fill.d = 0.0;
	if(larg)
		{
		ptr = (double *)arraystart(larg);
		switch(lbnd)
			{
		case 2: fill.d = ptr[1];
		case 1: delim.d = ptr[0];
			}
		}
}

/*	a d d   f u n c t i o n s 
	add an element of one type to the results array.
	entry codes:
	0 = increment relevant member of the `from' union.
	1 = add fill element from the `fill' union.
	2 = add data from the `from' union.
	3 = add delimiter from the `delim' union.
*/

void	addintg(code)
REG short code;
{
	if(code)
		*to.i++ = (code==1)? fill.i :(code==2)?*from.i :delim.i;
	else
		++from.i;
}

void	addlong(code)
REG short code;
{
	if(code)
		*to.l++ = (code==1)? fill.l :(code==2)?*from.l :delim.l;
	else
		++from.l;
}

void	adddoub(code)
REG short code;
{
	if(code)
		*to.d++ = (code==1)? fill.d :(code==2)?*from.d :delim.d;
	else
		++from.d;
}

/*	c m p   f u n c t i o n s
	compare element of data to either fill element or delimiter.
	arguments:
	1 = compare data in `from' union to element in `delim' union.
	2, pointer = compare the *ptr to element in `fill' union.
*/

UNS	cmpintg(code,vptr)
REG short	code;
void *vptr;
{
	return 1 == code ? delim.i == *from.i : fill.i == *(short *)vptr;
}

UNS	cmplong(code,vptr)
REG short	code;
void *vptr;
{
	return 1 == code ? delim.l == *from.l : fill.l == *(long *)vptr;
}

UNS	cmpdoub(code,vptr)
REG short	code;
void *vptr;
{
	return 1 == code ? delim.d == *from.d : fill.d == *(double *)vptr;
}

/*	s i z e e l
	returns size in bytes of apl variables
*/
	
sizeel(eltype)
REG UNS eltype;
{
	static int elsize[] =
		{
		/* 0 CHAR */	sizeof(UCHAR),
		/* 1 BOOL */	-1,
		/* 2 SINT */	sizeof(UCHAR),
		/* 3 INTG */	sizeof(short),
		/* 4 LONG */	sizeof(long),
		/* 5 DOUB */	sizeof(double)
		};

	return elsize[eltype];
}

UCHAR	*zmalloc(size)
UNS size;
{
	REG UCHAR *ret = malloc(size + !size); // malloc(0) is undefined

	if(0 == ret)
		error(LIMIT);
	return	ret;
}

UCHAR	*zrealloc(ptr, size)
UCHAR	*ptr;
UNS	size;
{
	ptr = realloc(ptr, size);
	if(0 == ptr)
		error(LIMIT);
	return	ptr;
}

#ifdef	DOS

#if	0

	{R} <- {X} copyseg Y

	Y specifies attributes of X and R
	Y is a 4 element numeric vector
	Y[0] <-> size of each item in bytes 1 or 2 or 4
	Y[1] <-> number of items
	Y[2] <-> protected mode segment number, some useful values are
		28 <-> maps the screen
		44 <-> maps the enviroment block
		64 <-> maps all of physical memory
		96 <-> maps the first 1 Meg of memory ( MS-DOS )
	Y[3] <-> offset of first item in segment

	X if present specifies the values to be written to memory
	X is a numeric scalar or vector of signed values which fit in width Y[0]

	R is the values which were in those memory locations before the write.

	To find out the contents of the first row of the screen
		+copyseg 1 160 28 0
	gives a vector of length 160 containg char,attr,char,attr,...

	To write to the screen a row of white 'D's on a blue background
		(160 reshape 68 23)copyseg 1 160 28 0

	Note:
	This code works with protected mode addresses. If you want to access
	a real mode address seg:offset then the protected mode address is
		protected segment 96
		protected offset 16 1+.x seg offset
#endif	// 0 

#include	<hardware.h>

ARRAY *copyseg(ARRAY *larg, ARRAY *rarg)
{
	unsigned nitems, item_width, nbytes, restype;
	ARRAY *rslt;

	switch(rarg->eltype)
		{
	default:domain();		// rarg must be numeric simple 
	case BOOL: case SINT: case INTG: case DOUB:	// convert it to LONG 
		{
		ARRAY *tmp = (*convfns[rarg->eltype][LONG])(rarg);
	
		freearray(rarg); *Rarg = rarg = tmp;
		}
	case LONG:
		break;
		}
	switch(rarg->rank)
		{
	default:error(RANK);		// rarg must be a vector 
	case 1: break;
		}
	switch(rarg->shape[0])
		{
	default:error(LENGTH);
	case 4:	break;
		}
	if(rarg->shape[2] < 0) domain();
	nitems = rarg->shape[2];
	restype = SINT;
	switch(item_width = rarg->shape[1])
		{
	default:domain();	// only some data widths are supported 
	case 4:	++restype;
	case 2:	++restype;
	case 1:	break;
		}
	if(larg)
		{
		switch(larg->eltype)
			{
		default:domain();	// must be a numeric type 
		case BOOL: case SINT: case INTG: case LONG: case DOUB:
			if(larg->eltype != restype)
				{
				ARRAY *tmp = (*convfns[larg->eltype][restype])(larg);

				freearray(larg);
				*Larg = larg = tmp;
				}
			break;
			}
		switch(larg->rank)
			{
		default:error(RANK);
		case 0:
			{
			unsigned one[1] = { 1 };
			ARRAY *tmp = mkarray(restype, 1, one);
		
			tmp->shape[1] = larg->shape[0];
			freearray(larg);
			*Larg = larg = tmp;
			}
		case 1:
			if(larg->shape[0] != nitems) error(LENGTH);
			break;
			}
		}

	nbytes = item_width * nitems;
	*Rslt = rslt = mkarray(restype, 1, &nitems);
		{
		FARP remote = { rarg->shape[4], rarg->shape[3] };
		FARP remtop = { rarg->shape[4] + nbytes - 1, rarg->shape[3] };
		FARP to     = { (unsigned)&rslt->shape[1], MYDATA() };

		switch(TESTACCESS(&remote))
			{
		default:domain();		// no access 
		case 1: if(larg) domain();	// readable  
		case 3:	break;			// read and write 
			}
		if(nbytes > 1)switch(TESTACCESS(&remtop))
			{
		default:domain();
		case 1: if(larg) domain();
		case 3:	break;
			}
		COPYSEG(&to, &remote, nbytes);
		if(larg)
			{
			FARP from = { (unsigned)&larg->shape[1], MYDATA() };

			COPYSEG(&remote, &from, nbytes);
			}
		}
	return rslt;
}


#if	0

	{R} <- {X} interrupt Y

	Issue Phar Lap interrupt.

	Y is a numeric integer scalar between 0 and 255.

	X if present must be a nine element numeric integer vector
	  which specifies the contents of the registers in the order
	  EAX, EBX, ECX, EDX, ESI, EDI, DS, ES, EFLAGS

	  If X is not present it is treated as 9 reshape 0.

	R is the content of the registers after the interrupt has returned.

	eg. To find out the total and unused portions of the C: drive you might
	use
		EDX <- 3
		EAX <- 54x256
		REG <- EAX 0 0 EDX 0 0 0 0 0
		+REG interrupt 33

	notes:
	For calls that indicate failure by setting the carry flag the EFLAGS
	register in the result will be odd.

	The DS and ES registers are for protected mode segments. If given
	values they must specify writeable segments.

	To use the DS or ES registers a previous call must have allocated some
	memory eg

	QuadIO <- 0
	EBX <- 1
	EAX <- 72x256					function 48 hex
	REG <- EAX EBX 0 0 0 0 0 0 0 interrupt 33	request 1 page seg
	QuadSIGNAL (2|REG[8])/10			limit error if failed
	DS <- (2*16)|REG[0]				new seg in AX
	EAX <- 71x256					function 47 hex
	EDX <- 3					drive C:
	ESI <- 0					DS:0
	REG <- EAX 0 0 EDX ESI 0 DS 0 0 interrupt 33	get current directory
	QuadSIGNAL (2|REG[8])/11			domain error if failed
	NAME <- copyseg 1 64 DS 0			get the 64 byte buffer
	NAME <- (NAME iota 0) take NAME			ASCIIZ string
	ASCIIAV[NAME]					current C: directory
	ES <- DS
	EAX <- 73x256					function 49 hex
	REG <- EAX 0 0 0 0 0 0 ES 0 interrupt 33	free segment
	QuadSIGNAL (2|REG[8])/11			domain error if failed

#endif	// 0 


#undef	L		// quadav.h macro clashes with msdos.cf 
#undef	H		// quadav.h macro clashes with msdos.cf 
#undef	R		// quadav.h macro clashes with msdos.cf 
#undef	W		// quadav.h macro clashes with msdos.cf 
#undef data		// support.h macro clashes with msdos.cf 
#include <msdos.cf>	// metaware HIGHC include file 
#define NREGS	9	// number of registers to specify 

ARRAY *interrupt(ARRAY *larg, ARRAY *rarg)
{
	ARRAY *rslt;

	if(!larg)
		{
		unsigned len = NREGS;

		*Larg = larg = mkarray(LONG, 1, &len);
		memset(arraystart(larg), 0, len*sizeof(long));
		}
	switch(larg->eltype)
		{
	default: domain();	// must be numeric type 
	case BOOL: case SINT: case INTG: case DOUB:
		{
		ARRAY *tmp = (*convfns[larg->eltype][LONG])(larg);
	
		freearray(larg); *Larg = larg = tmp;
		}
	case LONG:
		break;
		}
	switch(larg->rank)
		{
	default:error(RANK);
	case 1:
		break;
		}
	if(larg->shape[7])	// DS register specified 
		{
		FARP ds = { 0, larg->shape[7] };

		switch(TESTACCESS(&ds))
			{
		default:domain();	// insist on a writable seg 
		case 3: break;
			}
		}
	if(larg->shape[8])	// ES register specified 
		{
		FARP es = { 0, larg->shape[8] };

		switch(TESTACCESS(&es))
			{
		default:domain();	// insist on a writable seg 
		case 3: break;
			}
		}
	switch(larg->shape[0])
		{
	default:error(LENGTH);
	case NREGS:
		break;
		}
	switch(rarg->eltype)
		{
	default: domain();	// must be numeric type 
	case BOOL: case SINT: case INTG: case DOUB:
		{
		ARRAY *tmp = (*convfns[rarg->eltype][LONG])(rarg);
	
		freearray(rarg); *Rarg = rarg = tmp;
		}
	case LONG:
		break;
		}
	switch(rarg->rank)
		{
	default:error(RANK);
	case 0:
		break;
		}
	if(255 < rarg->shape[0] || 0 > rarg->shape[0]) domain();

	{
	unsigned len = NREGS;

	*Rslt = rslt = mkarray(LONG, 1, &len);
	}

	memcpy(&Registers, &larg->shape[1], sizeof(Registers));
	callint(rarg->shape[0]);
	memcpy(&rslt->shape[1], &Registers, sizeof(Registers));
	return rslt;
}



#if	0
	{R} <- {X} port Y

	Y is a 3 column matrix of port specifiers

	Y[;0] <-> port number in range 0 to 65535
	Y[;1] <-> port width 1 or 2 or 4 ( note 0=Y[;1]|Y[;0] )
	Y[;2] <-> read or write  0 <-> read, 1 <-> write

	X is a vector of values to be written to the ports
	  the values must be representable as signed integers
	  in the width given in Y[;2].
	
	The length of X is +/Y[;2]

	X may only be absent if 0=+/Y[;2]

	R is a vector of values read from the ports

	The length of R is +/~Y[;2]

	eg. To find the scan code of the last key pressed

		SCAN<-port 1 3 reshape 96 1 0

	eg. To save the font information from an EGA/VGA card
	    Warning DONT try this in desk calculator mode.
	    Nothing must try to write to the screen between the 2 calls on port.

		SET<-4 6 5 0 6 12 4 2
		RESET<-4 2 5 16 6 14 4 0
		PORTS<-960 + 4 5 14 15 14 15 14 15		0x3c0 is 960
		PORTS<-PORTS jot.* 1 0 0	3 col matrix extended with 1s
		SET port PORTS			write only ports on EGA
		FONT<-copyseg 1 (32x1024) 28 0
		RESET port PORTS

	The restriction of supplying correct width signed integers can be
	less onerous if the following function is used.

		[0] NUMS<-BASE unsigned NUMS;SHAPE
		[1] NUMS top commute <- BASE
		[2] SHAPE<- rho NUMS
		[3] (first SHAPE)<- 1
		[4] NUMS x<- 1+(rho NUMS) take SHAPE reshape negative 2
		[5] NUMS base commute <- BASE

	note that BASE must be a vector.

		2 2 2 2 2 2 2 2 unsigned 1 2 254 255
	1 2 -2 -1
		
#endif	// 0 



ARRAY *port(ARRAY *larg, ARRAY *rarg)
{
	ARRAY *rslt;
	int *resp, *lp, *rp, *lplim;
	unsigned i, nreads;

	if(!larg)
		{
		int len = 0;

		*Larg = larg = mkarray(LONG, 1, &len);
		}
	switch(larg->eltype)
		{
	default: domain();	// must be numeric type 
	case BOOL: case SINT: case INTG: case DOUB:
		{
		ARRAY *tmp = (*convfns[larg->eltype][LONG])(larg);
	
		freearray(larg); *Larg = larg = tmp;
		}
	case LONG:
		break;
		}
	switch(larg->rank)
		{
	default:error(RANK);
	case 1:	break;
		}
	switch(rarg->eltype)
		{
	default: domain();	// must be numeric type 
	case BOOL: case SINT: case INTG: case DOUB:
		{
		ARRAY *tmp = (*convfns[rarg->eltype][LONG])(rarg);
	
		freearray(rarg); *Rarg = rarg = tmp;
		}
	case LONG:
		break;
		}
	switch(rarg->rank)
		{
	default:error(RANK);
	case 2: break;
		}
	switch(rarg->shape[1])
		{
	default:error(LENGTH);
	case 3: break;
		}
	rp = (int *)&rarg->shape[2];
	lp = (int *)&larg->shape[1];
	lplim = lp + larg->shape[0];
	for(i = rarg->shape[0] ; i--; rp += 3)
		{
		if(lp == lplim && rp[2]) error(LENGTH);
		lp += testport(lp, rp);
		if(lp > lplim) error(LENGTH);
		}
	if(lp < lplim)error(LENGTH);
	nreads = rarg->shape[0] - larg->shape[0];
	*Rslt = rslt = mkarray(LONG, 1, &nreads);
	rp = (int *)&rarg->shape[2];
	lp = (int *)&larg->shape[1];
	resp = (int *)&rslt->shape[1];
	for(i = rarg->shape[0] ; i--; rp += 3)
		{
		if(doport(resp, lp, rp)) lp++;
		else resp++;
		}
	return rslt;
}

int testport(int *lp, int rvec[3])
{
	if(rvec[0] < 0 || rvec[0] > 65535) domain();
	switch(rvec[1])
		{
	default:domain();
	case 4: if(rvec[0] & 3) domain();
	case 2: if(rvec[0] & 1) domain();
	case 1: break;
		}
	switch(rvec[2])
		{
	default:domain();
	case 1:
		{
		switch(rvec[1])
			{
		case 1:
			{
			volatile unsigned char tmp;

			tmp = *lp;
			if(tmp != *lp) domain();
			break;
			}
		case 2:
			{
			volatile short tmp;

			tmp = *lp;
			if(tmp != *lp) domain();
			break;
			}
		case 4:
			break;
			}
		}
	case 0: break;
		}
	return rvec[2];

}

int doport(int *resp, int *lp, int rvec[3])
{
	static int (*in[5])(int) =
		{ 0, INP,  INPW,  0, INPD };
	static void (*out[5])(int, int) =
		{ 0, OUTP, OUTPW, 0, OUTPD};

	switch(rvec[2])
		{
	case 0:
		*resp = (*in[rvec[1]])(rvec[0]);
		break;
	case 1:
		(*out[rvec[1]])(rvec[0], *lp);
		break;
		}
	
	return rvec[2];
}

#endif	// DOS 

#if	defined(WATCOM)
/*
	Crude getenv()
	restricted to Upper Case Alpha
	and vectors (does not cope with scalar arguments)
	name must be less than 256 characters long
	no leading or trailing spaces
*/
static ARRAY* gtenv(ARRAY *rarg)
	{
	unsigned char name[256];
	unsigned len;
	unsigned *up;
	unsigned char *envp, *ap;
	ARRAY * rslt;

	switch(rarg->eltype)
		{
	case CHAR:
		break;
	default:
		error(DOMAIN);
		break;
		}
	switch(rarg->rank)
		{
	case 1:
		break;
	default:
		error(RANK);
		}

	up = rarg->shape;
	len = *up++;

	switch(256 <= len)
		{
	case 0:
		break;
	default:
		error(LENGTH);
		}
	memcpy(name, up, len);
	name[len] = 0;
	envp = (void *)getenv(name);
	switch(0 != envp)
		{
	case 0:			// the enviroment var does not exist
		len = 0;
		rslt = mkarray(LONG, 1, &len);
		break;		// return Zilde
	default:
		len = strlen(envp);
		rslt = mkarray(CHAR, 1, &len);
		for
			(
			ap = (void *)&rslt->shape[1]
		;	len--
		;	*ap++ = unixtoav(*envp++)
			);
		break;
		}
	return rslt;
	}

#endif//defined(WATCOM)

//	Copyright (c) 1982 Dyadic Systems Limited	
